version 11.2

*adjust working directory!

use replication.dta, clear

xtset party year
xtgls chrile incl chpmean ichpmean chcmean ichcmean niche Nchcmean Nchpmean i.country, corr(ar1) panels(heteroscedastic) force


matrix v = e(V)
drop _all
set obs 8
gen n = _n
gen hi = .
gen lo = .
gen mean =.

local pos1 = 2 
local pos2 = 3
local pos3 = 4
local pos4 = 5

forvalues a = 0/1 {
	local pmean = _b[chpmean]+ (`a' * _b[ichpmean])
	local se_pmean = sqrt(v[`pos1',`pos1']+((`a'^2)*v[`pos2',`pos2'])+(2*`a'*v[`pos2',`pos1']))
	local in_p = `a' +1

	replace lo = `pmean' - (1.96*`se_pmean') in `in_p'
	replace hi = `pmean' + (1.96*`se_pmean') in `in_p'
	replace mean = `pmean' in `in_p'
	
	local cmean = _b[chcmean]+ (`a' * _b[ichcmean])
	local se_cmean = sqrt(v[`pos3',`pos3']+((`a'^2)*v[`pos4',`pos4'])+(2*`a'*v[`pos4',`pos3']))
	local in_c = `a' +3
	
	replace lo = `cmean' - (1.96*`se_cmean') in `in_c'
	replace hi = `cmean' + (1.96*`se_cmean') in `in_c'
	replace mean = `cmean' in `in_c'
	

}


local n_0 = _b[chpmean]
local n_1 = _b[chpmean]+_b[Nchpmean]

local se_n_0 = _se[chpmean]
local se_n_1 = sqrt(v[2,2]+((1^2)*v[8,8])+(2*1*v[8,2]))

local n_c_0 = _b[chcmean]
local n_c_1 = _b[chcmean]+_b[Nchcmean]

local se_n_c_0 = _se[chcmean]
local se_n_c_1 = sqrt(v[4,4]+((1^2)*v[7,7])+(2*1*v[7,4]))

replace hi = `n_0' +[1.96*`se_n_0'] in 5
replace hi = `n_1' +[1.96*`se_n_1'] in 6
replace hi = `n_c_0'  +(1.96*`se_n_c_0') in 7
replace hi = `n_c_1' +(1.96*`se_n_c_1') in 8


replace lo = `n_0' -[1.96*`se_n_0'] in 5
replace lo = `n_1' -[1.96*`se_n_1'] in 6
replace lo = `n_c_0'  -(1.96*`se_n_c_0') in 7
replace lo = `n_c_1' -(1.96*`se_n_c_1') in 8

replace mean = `n_0' in 5
replace mean = `n_1' in 6
replace mean = `n_c_0' in 7
replace mean = `n_c_1' in 8

gen type = "gls"
save gls, replace

use replication.dta, clear

xtset party year
xtreg chrile incl chpmean ichpmean chcmean ichcmean niche Nchcmean Nchpmean lchrile, robust re

matrix v = e(V)
drop _all
set obs 8
gen n = _n
gen hi = .
gen lo = .
gen mean =.

local pos1 = 2 
local pos2 = 3
local pos3 = 4
local pos4 = 5

forvalues a = 0/1 {
	local pmean = _b[chpmean]+ (`a' * _b[ichpmean])
	local se_pmean = sqrt(v[`pos1',`pos1']+((`a'^2)*v[`pos2',`pos2'])+(2*`a'*v[`pos2',`pos1']))
	local in_p = `a' +1

	replace lo = `pmean' - (1.96*`se_pmean') in `in_p'
	replace hi = `pmean' + (1.96*`se_pmean') in `in_p'
	replace mean = `pmean' in `in_p'
	
	local cmean = _b[chcmean]+ (`a' * _b[ichcmean])
	local se_cmean = sqrt(v[`pos3',`pos3']+((`a'^2)*v[`pos4',`pos4'])+(2*`a'*v[`pos4',`pos3']))
	local in_c = `a' +3
	
	replace lo = `cmean' - (1.96*`se_cmean') in `in_c'
	replace hi = `cmean' + (1.96*`se_cmean') in `in_c'
	replace mean = `cmean' in `in_c'
	

}


local n_0 = _b[chpmean]
local n_1 = _b[chpmean]+_b[Nchpmean]

local se_n_0 = _se[chpmean]
local se_n_1 = sqrt(v[2,2]+((1^2)*v[8,8])+(2*1*v[8,2]))

local n_c_0 = _b[chcmean]
local n_c_1 = _b[chcmean]+_b[Nchcmean]

local se_n_c_0 = _se[chcmean]
local se_n_c_1 = sqrt(v[4,4]+((1^2)*v[7,7])+(2*1*v[7,4]))

replace hi = `n_0' +[1.96*`se_n_0'] in 5
replace hi = `n_1' +[1.96*`se_n_1'] in 6
replace hi = `n_c_0'  +(1.96*`se_n_c_0') in 7
replace hi = `n_c_1' +(1.96*`se_n_c_1') in 8


replace lo = `n_0' -[1.96*`se_n_0'] in 5
replace lo = `n_1' -[1.96*`se_n_1'] in 6
replace lo = `n_c_0'  -(1.96*`se_n_c_0') in 7
replace lo = `n_c_1' -(1.96*`se_n_c_1') in 8

replace mean = `n_0' in 5
replace mean = `n_1' in 6
replace mean = `n_c_0' in 7
replace mean = `n_c_1' in 8

gen type = "fe"
replace n = n + 0.2
append using gls




#delimit ;
graph twoway 
rcap lo hi n if n>=1 & n<3, lwidth(medium) lcolor(black)  vertical ||
scatter mean n if n==1|n==2, msymbol(O) mfcolor(black) msize(medium) mcolor(black) ||
scatter mean n if ((n>1&n<2)|(n>2&n<3)), msymbol(O) mfcolor(white) msize(medium) mcolor(black)||,
	yline(0, lcolor(black) lwidth(vvthin))
	xlabel(1.1 "Exclusive" 2.1 "Inclusive")
	xtitle("")
	legend(off)
	saving(pmean_4, replace)
	graphregion(color(white))
	plotregion(color(white))
	ylabel(, nogrid)
	xscale(range(0.5 2.5))
	title(Shift Mean Supporter, color(black)) 
	l1title(Blla, color(white))
	;
#delimit cr;

preserve
drop if n <3
replace n = n -2


#delimit ;
graph twoway 
rcap lo hi n if n>=1 & n<3, lwidth(medium) lcolor(black)  vertical ||
scatter mean n if n==1|n==2, msymbol(O) mfcolor(black) msize(medium) mcolor(black) ||
scatter mean n if ((n>1&n<2)|(n>2&n<3)), msymbol(O) mfcolor(white) msize(medium) mcolor(black)||,
	yline(0, lcolor(black) lwidth(vvthin))
	xlabel(1.1 "Exclusive" 2.1 "Inclusive")
	xtitle("")
	legend(off)
	saving(cmean_4, replace)
	graphregion(color(white))
	plotregion(color(white))
	ylabel(, nogrid)
	xscale(range(0.5 2.5))
	title(Shift Mean Voter, color(black))

	;
#delimit cr;

drop if n <3
replace n = n -2

#delimit ;
graph twoway 
rcap lo hi n if n>=1 & n<3, lwidth(medium) lcolor(black)  vertical ||
scatter mean n if n==1|n==2, msymbol(O) mfcolor(black) msize(medium) mcolor(black) ||
scatter mean n if ((n>1&n<2)|(n>2&n<3)), msymbol(O) mfcolor(white) msize(medium) mcolor(black)||,
	xlabel(1 "Mainstream" 2 "Niche")
	yline(0, lcolor(black) lwidth(vvthin))
	xtitle("")
	legend(off)
	saving(pmean_4_n, replace)
	graphregion(color(white))
	plotregion(color(white))
	ylabel(, nogrid)
	xscale(range(0.5 2.5))
	l1title(Just something to fit the graphs, color(white) size(large))
	;
#delimit cr;

drop if n ==1|n==2
replace n = n-2

#delimit ;
graph twoway
rcap lo hi n if n>=1 & n<3, lwidth(medium) lcolor(black)  vertical ||
scatter mean n if n==1|n==2, msymbol(O) mfcolor(black) msize(medium) mcolor(black) ||
scatter mean n if ((n>1&n<2)|(n>2&n<3)), msymbol(O) mfcolor(white) msize(medium) mcolor(black)||,
	xlabel(1 "Mainstream" 2 "Niche")
	yline(0, lcolor(black) lwidth(vvthin))
	xtitle("")
	legend(off)
	saving(cmean_4_n, replace)
	graphregion(color(white))
	plotregion(color(white))
	ylabel(, nogrid)
	xscale(range(0.5 2.5))
	;
#delimit cr;



#delimit ;
graph combine pmean_4.gph cmean_4.gph pmean_4_n.gph cmean_4_n.gph,
commonscheme
cols(2)
rows(2)
graphregion(color(white))
plotregion(color(white))
l1title(Marginal Effect on Change in Party Position)
saving(figure3.gph, replace)
ycommon
xcommon
;
#delimit cr;

erase pmean_4.gph
erase cmean_4.gph
erase pmean_4_n.gph
erase cmean_4_n.gph
erase gls.dta
